<?php

// Check if multisite, if so then save as site option

if (is_multisite()) {
	$version = get_site_option(self::$prefix . 'version');
} else {
	$version = get_option(self::$prefix . 'version');
}

// Create all the tables upon activation

include_once(WPSITE_POPUP_PLUGIN_DIR . "/admin/model/db.php");
include_once(WPSITE_POPUP_PLUGIN_DIR . "/core/model/stats.php");
include_once(WPSITE_POPUP_PLUGIN_DIR . "/core/model/email-signups.php");

WPsite_Popup_DB::createTable();
WPsite_Email_Signups_PF::createTable();
WPsite_Stats_PF::createTable();

if ($version !== false) {

	// Restructure table to allow for international characters

	if (version_compare($version, '2.0.1', '<=') && version_compare(WPSITE_POPUP_VERSION_NUM, '2.0.1', '>=')) {

		global $wpdb;

		include_once(WPSITE_POPUP_PLUGIN_DIR . "/admin/model/db.php");

		if ( !is_multisite() ) {

			// Alter character sets

			$query = $wpdb->query("ALTER TABLE `" . WPsite_Popup_DB::getTableName() . "` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci;");

		} else {

		    $blog_ids = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );
		    $original_blog_id = get_current_blog_id();

		    foreach ( $blog_ids as $blog_id ) {
		        switch_to_blog( $blog_id );

				// Alter character sets

				$query = $wpdb->query("ALTER TABLE `" . WPsite_Popup_DB::getTableName() . "` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci;");

		    }

		    restore_current_blog();
		}
	}

	// Add admin notice for update to 1.2 about new fonts and modify data structure

	if (version_compare($version, '1.1.2', '<=') && version_compare(WPSITE_POPUP_VERSION_NUM, '1.1.2', '>=')) {

		// Set transient for new admin notice

		set_transient(self::$prefix . 'admin_notice_mailchimp', '0', 0);
	}
}

// Check if multisite, if so then save as site option

if (is_multisite()) {
	update_site_option(self::$prefix . 'version', WPSITE_POPUP_VERSION_NUM);
} else {
	update_option(self::$prefix . 'version', WPSITE_POPUP_VERSION_NUM);
}