<?php

/*
 * This file is used for controlling the data for the Add / Edit page
 */

include_once(WPSITE_POPUP_PLUGIN_DIR . '/admin/model/db.php');

$wpsite_popup_db = new WPsite_Popup_DB();

global $wp_roles;

$post_types = get_post_types(array('public' => true));

// If the user saves a popup

if ( ( isset($_POST['submit-top']) || isset($_POST['submit-bottom']) || isset($_POST['submit_aweber']) ) && check_admin_referer(self::$prefix . 'admin_settings')) {

	if (empty($_POST[self::$prefix_dash . 'name'])) {
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}

	$popup = WPsite_Popups_Admin_Functions::save_data();

	// Redirect User to All Popups page after they add a popup

	if ( ( isset($_POST["submit-top"]) && $_POST["submit-top"] == "Save" ) || ( isset($_POST["submit-bottom"]) && $_POST["submit-bottom"] == 'Save' ) ) {
		$wpsite_popup_db->add_data($popup);
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}

	// Redirect User to All Popups page after they save a popup

	if ( ( isset($_POST["submit-top"]) && $_POST["submit-top"] == "Update" ) || ( isset($_POST["submit-bottom"]) && $_POST["submit-bottom"] == 'Update' ) ) {
		$popup['id'] = $_GET['popup_id'];
		$wpsite_popup_db->update_data($popup);
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}
}

$default_popup = WPsite_Popups_Admin_Functions::default_popup();

// Check if updating a record or adding a new one

if (isset($_GET["popup_id"])) {
	$edit_data = $wpsite_popup_db->get_data_from_id($_GET["popup_id"]);
} else {

	// Create default values from all post types

	$trigger = $default_popup['trigger'];

	foreach ($post_types as $post_type) {
		$trigger[$post_type] = array(
			'all'	=>	true,
			'id'	=>	''
		);
	}

	$trigger['type'] = 'site';
	$trigger['category'] = array(
		'all' 	=> true,
		'id' 	=> ''
	);
	$trigger['tag'] = array(
		'id' => ''
	);

	$edit_data = array_merge($default_popup, array('trigger' => $trigger));
}

// Unserialize all arrays

if (isset($edit_data['template']) && !is_array($edit_data['template'])) $edit_data['template'] = (array) WPsite_Popups_Admin_Functions::mb_unserialize($edit_data['template']);
if (isset($edit_data['style']) && !is_array($edit_data['style'])) $edit_data['style'] = (array) unserialize($edit_data['style']);
if (isset($edit_data['trigger']) && !is_array($edit_data['trigger'])) $edit_data['trigger'] = (array) unserialize($edit_data['trigger']);
if (isset($edit_data['social']) && !is_array($edit_data['social'])) $edit_data['social'] = (array) unserialize($edit_data['social']);
if (isset($edit_data['news_letter']) && !is_array($edit_data['news_letter'])) $edit_data['news_letter'] = (array) unserialize($edit_data['news_letter']);
if (isset($edit_data['args']) && !is_array($edit_data['args'])) $edit_data['args'] = (array) WPsite_Popups_Admin_Functions::mb_unserialize($edit_data['args']);

// Detect if in A/B Test

$ab_test = false;

if (isset($edit_data['args']['ab_testing']['active']) && $edit_data['args']['ab_testing']['active']) {
	$ab_test = true;
}

// If MailChimp Double opt-in is not set then default it to true

if ( !isset($edit_data['news_letter']['MailChimp']['optin']) ) {
	$edit_data['news_letter']['MailChimp']['optin'] = true;
}

// Include the Add Edit php file for all settings

include_once(WPSITE_POPUP_PLUGIN_DIR . '/admin/views/add-edit.php');

$post_types_array = array();
foreach ($post_types as $post_type) {
	$post_types_array[] = $post_type;
}

wp_localize_script(self::$prefix . 'admin_add_edit_js', 'wps_pf_data', array(
	'ajaxurl'       => admin_url( 'admin-ajax.php' ),
	'prefix'		=> self::$prefix,
	'prefix_dash' 	=> self::$prefix_dash,
	'post_types'	=> $post_types_array,
));